#!/usr/bin/python

import os,sys
from lxml import etree
from random import randint

def main():
    tree = etree.parse('shadow.config.singlefile.xml')
    root = tree.getroot()

    # remove extra hosts
    for host in root.iter('node'):
        hid = host.attrib['id']
        if 'webclient' in hid:
            n = int(hid[9:])
            if n > 11943: # this is how many web clients we want
                host.getparent().remove(host)
            else:
                for app in host.iter('application'):
                    if app.attrib['plugin'] == 'tgen':
                        r = randint(1, 100) # we have 100 httparchive parts
                        app.set("arguments", "conf/httparchive-tgen-configs/tgen.httparchive.part{}.graphml.xml".format(r))

        if 'bulkclient' in hid:
            n = int(hid[10:])
            if n > 887: # this is how many bulk clients we want
                host.getparent().remove(host)
            else:
                for app in host.iter('application'):
                    if app.attrib['plugin'] == 'tgen':
                        r = randint(1, 100) # we have 100 httparchive parts
                        app.set("arguments", "conf/tgen.btclient.graphml.xml")

    for i in xrange(1, 101): # tgen.btclient.graphml.xml expects 100 bt servers
        e = etree.SubElement(root, "node")
        e.set("id", "btserver{}".format(i))
        e.set("bandwidthup", "122070")
        e.set("bandwidthdown", "122070")
        e.set("cpufrequency", "10000000")
        e.set("typehint", "server")
        a = etree.SubElement(e, "application")
        a.set("plugin", "tgen")
        a.set("starttime", "1")
        a.set("arguments", "conf/tgen.btserver.graphml.xml")

    with open('shadow.config.xml', 'w') as fout:
        fout.write(etree.tostring(root, pretty_print=False, xml_declaration=False))

if __name__ == '__main__':
    main()
